

# ListDetectors


**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Lists detectors (the instances of a detector model).

## Request Syntax


```
GET /detectors/detectorModelName?maxResults=maxResults&nextToken=nextToken&stateName=stateName HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [detectorModelName](#API_iotevents-data_ListDetectors_RequestSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-request-uri-detectorModelName"></a>
The name of the detector model whose detectors (instances) are listed.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [maxResults](#API_iotevents-data_ListDetectors_RequestSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-request-uri-maxResults"></a>
The maximum number of results to be returned per request.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_iotevents-data_ListDetectors_RequestSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-request-uri-nextToken"></a>
The token that you can use to return the next set of results.

 ** [stateName](#API_iotevents-data_ListDetectors_RequestSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-request-uri-stateName"></a>
A filter that limits results to those detectors (instances) in the given state.  
Length Constraints: Minimum length of 1. Maximum length of 128.

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "detectorSummaries": [ 
      { 
         "creationTime": number,
         "detectorModelName": "string",
         "detectorModelVersion": "string",
         "keyValue": "string",
         "lastUpdateTime": number,
         "state": { 
            "stateName": "string"
         }
      }
   ],
   "nextToken": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [detectorSummaries](#API_iotevents-data_ListDetectors_ResponseSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-response-detectorSummaries"></a>
A list of summary information about the detectors (instances).  
Type: Array of [DetectorSummary](API_iotevents-data_DetectorSummary.md) objects

 ** [nextToken](#API_iotevents-data_ListDetectors_ResponseSyntax) **   <a name="iotevents-iotevents-data_ListDetectors-response-nextToken"></a>
The token that you can use to return the next set of results, or `null` if there are no more results.  
Type: String

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-data-2018-10-23/ListDetectors) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-data-2018-10-23/ListDetectors) 